// SysInfoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SysInfo.h"
#include "SysInfoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSysInfoDlg dialog

CSysInfoDlg::CSysInfoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSysInfoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSysInfoDlg)
	m_info = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSysInfoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSysInfoDlg)
	DDX_Text(pDX, IDC_INFO, m_info);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSysInfoDlg, CDialog)
	//{{AFX_MSG_MAP(CSysInfoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_INFO, OnButtonInfo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSysInfoDlg message handlers

BOOL CSysInfoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSysInfoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSysInfoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSysInfoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSysInfoDlg::OnButtonInfo() 
{
	// TODO: Add your control notification handler code here


DWORD dr = GetLogicalDrives();
int n,d;
char dd[4];

  m_info += "System is ";
  DisplaySystemVersion();m_info += "\r\n";

 MEMORYSTATUS MemStat;
 char temp[100];

  MemStat.dwLength = sizeof(MEMORYSTATUS);
  GlobalMemoryStatus(&MemStat);
  m_info += "Total Physycal Memory : "; 
  _ltoa( (long)MemStat.dwTotalPhys / 1024, temp, 10 ); 
  m_info += (CString)&temp[0]; m_info += " Kb"; m_info += "\r\n";
    m_info += "Total Physycal Memory Available: "; 
  _ltoa( (long)MemStat.dwAvailPhys / 1024, temp, 10 ); 
  m_info += (CString)&temp[0]; m_info += " Kb"; m_info += "\r\n";
    m_info += "Total Virtual Memory : "; 
  _ltoa( (long)MemStat.dwTotalVirtual / 1024, temp, 10 ); 
  m_info += (CString)&temp[0]; m_info += " Kb"; m_info += "\r\n";
    m_info += "Total Virtual Memory Available: "; 
  _ltoa( (long)MemStat.dwAvailVirtual / 1024, temp, 10 ); 
  m_info += (CString)&temp[0]; m_info += " Kb"; m_info += "\r\n";m_info += "\r\n";


  			char ComputerName[MAX_COMPUTERNAME_LENGTH + 1];
			unsigned long len_ComputerName = MAX_COMPUTERNAME_LENGTH + 1;

	BOOL comp = GetComputerName(
		ComputerName,
		&len_ComputerName
		);

	if( comp != 0 ) { m_info += "Computer Name is "; m_info += &ComputerName[0]; m_info += "\r\n"; }	
	else m_info += "Computer Name is NOT FOUND !!! ";m_info += "\r\n";  

	comp = GetUserNameA (
		ComputerName,
		&len_ComputerName
		);

	if( comp != 0 ) { m_info += "User Name is "; m_info += &ComputerName[0]; m_info += "\r\n"; }	
	else m_info += "User Name is NOT FOUND !!! ";m_info += "\r\n"; m_info += "\r\n"; 
	
	m_info += "Disks on the computers : "; m_info += "\r\n";

for( int i = 0; i < 26; i++ )
{
	n = ((dr>>i)&0x00000001);
	if( n == 1 ) 
	{
		dd[0] =  char(65+i); dd[1] = ':'; dd[2] = '\\'; dd[3] = 0;
		m_info += (CString)dd; 
		d = GetDriveType( dd );
		if( d == DRIVE_UNKNOWN ) m_info += " - UNKNOWN";
		if( d == DRIVE_NO_ROOT_DIR ) m_info += " - DRIVE NO ROOT DIR";
		if( d == DRIVE_REMOVABLE ) m_info += " - REMOVABLE" ;
		if( d == DRIVE_FIXED ) m_info += " - FIXED";
		if( d == DRIVE_REMOTE ) m_info += " - REMOTE";
		if( d == DRIVE_CDROM ) m_info += " - CDROM";
		if( d == DRIVE_RAMDISK ) m_info += " - RAMDISK";
		
		m_info += "\r\n";

			char VolumeNameBuffer[100]; 
			char FileSystemNameBuffer[100];
			unsigned long VolumeSerialNumber;

		BOOL GetVolumeInformationFlag = GetVolumeInformationA(
			dd,
			VolumeNameBuffer,
			100,
			&VolumeSerialNumber,
			NULL, //&MaximumComponentLength,
			NULL, //&FileSystemFlags,
			FileSystemNameBuffer,
			100
		);  

		if(GetVolumeInformationFlag != 0) 
		{
			m_info += "	Volume Name is "; m_info += (CString)VolumeNameBuffer;m_info += "\r\n";
			char temp[100];
			_ui64toa( (unsigned int)VolumeSerialNumber, temp, 10 ); 
			m_info += "	Volume Serial Number is "; m_info += (CString)&temp[0];m_info += "\r\n";
			m_info += "	File System is "; m_info += (CString)FileSystemNameBuffer;m_info += "\r\n";
		}
		else m_info += "	Not Present (GetVolumeInformation)"; m_info += "\r\n";

			DWORD FreeBytesAvailable;   
			PULARGE_INTEGER TotalNumberOfBytes;
			PULARGE_INTEGER TotalNumberOfFreeBytes;

		BOOL GetDiskFreeSpaceFlag = GetDiskFreeSpaceEx(
			dd,						 // directory name
			(PULARGE_INTEGER)&FreeBytesAvailable,     // bytes available to caller
			(PULARGE_INTEGER)&TotalNumberOfBytes,     // bytes on disk
			(PULARGE_INTEGER)&TotalNumberOfFreeBytes  // free bytes on disk
		);

		if(GetDiskFreeSpaceFlag != 0) 
		{
			char temp[100];
			m_info += "	Total Size Free(MBytes) = "; 
			_ultoa( (unsigned long)TotalNumberOfFreeBytes/1024/1000, temp, 10 );
				m_info += (CString)&temp[0]; m_info += "\r\n";

			m_info += "	Total Size(MBytes) = "; 
			_ultoa( (unsigned long)TotalNumberOfBytes/1024/1000 , temp, 10 );
				m_info += (CString)&temp[0];m_info += "\r\n";

		}
		else	m_info += "	Not Present (GetDiskFreeSpace)"; m_info += "\r\n";
		
	}
}




		UpdateData( FALSE );
}

BOOL CSysInfoDlg::DisplaySystemVersion(VOID)
{
  OSVERSIONINFOEX osvi;
   BOOL bOsVersionInfoEx;

   // Try calling GetVersionEx using the OSVERSIONINFOEX structure,
   // which is supported on Windows 2000.
   //
   // If that fails, try using the OSVERSIONINFO structure.

   ZeroMemory(&osvi, sizeof(OSVERSIONINFOEX));
   osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);

   if( !(bOsVersionInfoEx = GetVersionEx ((OSVERSIONINFO *) &osvi)) )
   {
      // If OSVERSIONINFOEX doesn't work, try OSVERSIONINFO.

      osvi.dwOSVersionInfoSize = sizeof (OSVERSIONINFO);
      if (! GetVersionEx ( (OSVERSIONINFO *) &osvi) ) 
         return FALSE;
   }

   switch (osvi.dwPlatformId)
   {
      case VER_PLATFORM_WIN32_NT:

      // Test for the product.

         if ( osvi.dwMajorVersion <= 4 )
            m_info += "Microsoft Windows NT ";

         if ( osvi.dwMajorVersion == 5 )
            m_info += "Microsoft Windows 2000 ";

            HKEY hKey;
            char szProductType[80];
            DWORD dwBufLen;

            RegOpenKeyEx( HKEY_LOCAL_MACHINE,
               "SYSTEM\\CurrentControlSet\\Control\\ProductOptions",
               0, KEY_QUERY_VALUE, &hKey );
            RegQueryValueEx( hKey, "ProductType", NULL, NULL,
               (LPBYTE) szProductType, &dwBufLen);
            RegCloseKey( hKey );
            if ( lstrcmpi( "WINNT", szProductType) == 0 )
               m_info += "Workstation ";
            if ( lstrcmpi( "SERVERNT", szProductType) == 0 )
               m_info += "Server ";

      // Display version, service pack (if any), and build number.
		char temp[100];
		m_info += "version ";
		itoa( (int)osvi.dwMajorVersion, temp, 10 );
		m_info += (CString)&temp[0]; m_info += ".";
		itoa( (int)osvi.dwMinorVersion, temp, 10 );
		m_info += (CString)&temp[0]; m_info += " ";
		m_info += (CString)osvi.szCSDVersion;
		m_info += " (Build ";
		itoa( (int)(osvi.dwBuildNumber & 0xFFFF), temp, 10 );
		m_info += (CString)&temp[0]; m_info += ")"; m_info += "\r\n";
	
         break;

      case VER_PLATFORM_WIN32_WINDOWS:

         if ((osvi.dwMajorVersion > 4) || 
            ((osvi.dwMajorVersion == 4) && (osvi.dwMinorVersion > 0)))
         {
             m_info += "Microsoft Windows 98 ";
         } 
         else m_info += "Microsoft Windows 95 ";

         break;

      case VER_PLATFORM_WIN32s:

         m_info += "Microsoft Win32s ";
         break;
   }
   UpdateData( FALSE );
   return TRUE; 
}
